var Vue = require('vue');
var VueResource = require('vue-resource');
Vue.use(VueResource);

var wx = (function() {
    var fun = {};
    fun.request = function(options) {
        var url = options.url;
        if (!/http.*/.test(url) && config && config.server) {
            url = config.server + url;
        }
        console.log('url', url);
        var method = (options.method || 'get').toLowerCase();

        var reqOptions = {
            headers: options.header || null
        };
        var dataType = options.dataType || 'json';

        var successCallback = function(res) {
            var response = res[dataType] ? res[dataType]() : res.text();
            response.then(function(data) {
                res.data = data;
                if (typeof(options.success) === 'function') {
                    options.success(res);
                }
                if (typeof(options.complete) === 'function') {
                    options.complete();
                }
            })
        }
        var errorCallback = function(res) {
            if (typeof(options.fail) === 'function') {
                options.fail(res);
            }
            if (typeof(options.complete) === 'function') {
                options.complete();
            }
        }

        switch (method) {
            case 'post':
                console.log(reqOptions);
                Vue.http.post(url, options.data, reqOptions).then(successCallback, errorCallback);
                break;
            case 'get':
                if (options.data) {
                    var params = [];
                    for (var i in data) {
                        params.push(i + '=' + encodeURI(data[i]));
                    }
                    if (url.indexOf('?') > 0) {
                        url = url + params.join('&');
                    } else {
                        url = url + '?' + params.join('&');
                    }
                }
                Vue.http.get(url, reqOptions).then(successCallback, errorCallback);
                break;
            default:
                Vue.http.get(url, reqOptions).then(successCallback, errorCallback);
        }

    };

    fun.uploadFile = function(options) {

    };

    fun.downloadFile = function(options) {

    };


    fun.connectSocket = function(options) {};
    fun.onSocketOpen = function(options) {};
    fun.onSocketError = function(options) {};
    fun.sendSocketMessage = function(options) {};
    fun.onSocketMessage = function(options) {};
    fun.closeSocket = function(options) {};
    fun.onSocketClose = function(options) {};

    fun.chooseImage = function(options) {};

    fun.previewImage = function(options) {};
    fun.getImageInfo = function(options) {};
    fun.startRecord = function(options) {};
    fun.stopRecord = function(options) {};
    fun.getBackgroundAudioPlayerState = function(options) {};
    fun.playBackgroundAudio = function(options) {};
    fun.pauseBackgroundAudio = function(options) {};
    fun.seekBackgroundAudio = function(options) {};
    fun.stopBackgroundAudio = function(options) {};
    fun.onBackgroundAudioPlay = function(options) {};
    fun.onBackgroundAudioPause = function(options) {};
    fun.onBackgroundAudioSt = function(options) {};
    fun.createAudioContext = function(options) {};
    fun.chooseVideo = function(options) {};
    fun.createVideoContext = function(options) {};
    fun.playVoice = function(options) {};
    fun.pauseVoice = function(options) {};
    fun.stopVoice = function(options) {};
    fun.saveFile = function(options) {};
    fun.getSavedFileList = function(options) {};
    fun.getSavedFileInfo = function(options) {};
    fun.removeSavedFile = function(options) {};
    fun.openDocument = function(options) {};



    function storage(fn, options) {
        try {
            if (options) {
                if (options.key && options.data) {
                    localStorage[fn](options.key, options.data);
                } else {
                    localStorage[fn](options.key);
                }
            } else {
                localStorage[fn]();
            }
            typeof options.success == 'function' && options.success();
        } catch (e) {
            console.log(e);
            typeof options.fail == 'function' && options.fail(e);
        } finally {
            typeof options.complete == 'function' && options.complete();
        }
    }


    fun.setStorage = function(options) {
        storage('setItem', options);
    }

    fun.setStorageSync = function(options) {
        localStorage.setItem(options.key, options.data);
        return true;
    }

    fun.getStorage = function(options) {
        storage('getItem', options);
    };

    fun.getStorageSync = function(options) {
        var res = localStorage.getItem(options.key);
        return res == "undefined" ? null : res;
    };

    fun.getStorageInfo = function(options) {
        return {};
    };

    fun.getStorageInfoSync = function(options) {}

    fun.removeStorage = function(options) {
        storage('removeItem', options);
    };

    fun.removeStorageSync = function(options) {
        return localStorage.removeItem(options.key);
    };

    fun.clearStorage = function() {
        storage('clear');
    };

    fun.clearStorageSync = function() {
        return localStorage.clear();
    };

    fun.getLocation = function(options) {};
    fun.chooseLocation = function(options) {};
    fun.openLocation = function(options) {};
    fun.createMapContext = function(options) {};
    fun.getSystemInfo = function(options) {};
    fun.getSystemInfoSync = function(options) {};
    fun.getNetworkType = function(options) {};
    fun.onAccelerometerChangeCallback = function(options) {};
    fun.onCompassChange = function(options) {};
    fun.makePhoneCall = function(options) {};
    fun.showToast = function(options) {};
    fun.hideToast = function(options) {};
    fun.showModal = function(options) {};
    fun.showActionSheet = function(options) {};
    //设置导航条
    fun.setNavigationBarTitle = function(options) {};
    fun.showNavigationBarLoading = function(options) {};
    fun.hideNavigationBarLoading = function(options) {};

    var doNavOrRedirectOpt = function(type, options) { //处理跳转逻辑
        if (!type) {
            return;
        }
        if (!options) {
            return
        }
        var url;
        url = options.url || ''
        try {
            if (type === "navigateTo") {
                PVAPP.$router.push(url)
            } else if (type === "redirectTo") {
                PVAPP.$router.replace(url)
            } else if (type === "navigateBack") {
                var delta = options.delta
                if (!delta) {
                    return;
                }
                if (typeof delta !== 'number') {
                    return;
                }
                PVAPP.$router.go(delta)
            }
            try {
                if (options.success) {
                    options.success()
                }
            } catch (e) {}
        } catch (e) {
            try {
                if (options.fail) {
                    options.fail()
                }
            } catch (e) {}
        }

        try {
            if (options.complete) {
                options.complete()
            }
        } catch (e) {}
    }
    fun.navigateTo = function(options) {
        doNavOrRedirectOpt('navigateTo', options)
    };
    fun.redirectTo = function(options) {
        doNavOrRedirectOpt('redirectTo', options)
    };
    fun.switchTab = function(options) {};
    fun.navigateBack = function(options) {
        doNavOrRedirectOpt('navigateBack', options)

    };
    fun.createAnimation = function(options) {};
    fun.createCanvasContext = function(options) {};
    fun.createContext = function(options) {};
    fun.drawCanvas = function(options) {};
    fun.canvasToTempFilePath = function(options) {};
    fun.stopPullDownRefresh = function(options) {};
    fun.login = function(options) {
        var successCallback = function(res) {
            if (typeof(options.success) === 'function') {
                options.success(res);
            }
            if (typeof(options.complete) === 'function') {
                options.complete();
            }
        }

        var errorCallback = function(res) {
            if (typeof(options.fail) === 'function') {
                options.fail(res);
            }
            if (typeof(options.complete) === 'function') {
                options.complete();
            }
        }
        return successCallback(Math.random().toString(36).substr(2));
    };

    fun.checkSession = function(options) {};
    fun.scanCode = function(options) {};
    fun.getUserInfo = function(options) {
        var successCallback = function(res) {
            if (typeof(options.success) === 'function') {
                options.success(res);
            }
            if (typeof(options.complete) === 'function') {
                options.complete();
            }
        }

        var errorCallback = function(res) {
            if (typeof(options.fail) === 'function') {
                options.fail(res);
            }
            if (typeof(options.complete) === 'function') {
                options.complete();
            }
        }
        return successCallback({
            'nickName': 'mock'
        });
    };
    fun.requestPayment = function(options) {};

    return fun;
})();

export default wx
